#
# spec file for package multipath-tools (Version 0.4.5)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# neededforbuild  device-mapper readline readline-devel termcap udev

BuildRequires:  aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils device-mapper gcc gdbm gettext libtool perl readline-devel rpm termcap udev

Name:           HPDMmultipath-tools
Url:            http://christophe.varoqui.free.fr/
License:        GNU General Public License (GPL)
Group:          System/Base
Requires:       device-mapper
%if %suse_version > 800
PreReq:         %insserv_prereq
%endif
Autoreqprov:    on
Version:        4.0.0
Release:        SLES9.3
Summary:        Tools to manage multipathed devices with the device-mapper
Source:         HPDMmultipath-tools-%{version}.%{release}.tar.bz2
Source1:        multipathd
Source2:        mp-tools-issues.pdf
Source4:        boot.multipath
BuildRoot:      %{_tmppath}/HPDMmultipath-tools-%{version}.%{release}-build

%description
This package provides the tools to manage multipathed devices by
instructing the device-mapper multipath module what to do. The tools
are:

- multipath: scan the system for multipathed devices, assembles them
   and update the device-mapper's maps

- multipathd: wait for maps events, then execs multipath

- devmap-name: provides a meaningful device name to udev for devmaps

- kpartx: maps linear devmaps upon device partitions, which makes
multipath maps partionable
This package is derived from SLES9 SP3 multipath tools 0.4.7


Authors:
--------
    Christophe Varoqui <christophe.varoqui@free.fr>

%{name} provides the tools to manage multipathed devices by

%prep
%setup -n HPDMmultipath-tools-%{version}.%{release}
#%setup -T -D -a 5

%build
CFLAGS="$RPM_OPT_FLAGS" make BUILD=glibc

%install
mkdir -p $RPM_BUILD_ROOT/sbin
make DESTDIR=$RPM_BUILD_ROOT install
rm -rf $RPM_BUILD_ROOT/etc/hotplug.d
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m 744 %{SOURCE1} $RPM_BUILD_ROOT/etc/init.d
install -m 744 %{SOURCE4} $RPM_BUILD_ROOT/etc/init.d
rm -rf $RPM_BUILD_ROOT/etc/dev.d
rm -rf $RPM_BUILD_ROOT/etc/udev/rules.d
mkdir -p $RPM_BUILD_ROOT/var/cache/multipath/

%clean
[ "$RPM_BUILD_ROOT" != / ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%pre
if [ -f /etc/init.d/multipathd ] && dmsetup table | grep -q multipath ; then
    /etc/init.d/multipathd stop
fi

%post
if dmsetup table | grep -q multipath ; then
    /etc/init.d/multipathd start
fi
#%{insserv /etc/init.d/multipathd}
#%{fillup_and_insserv boot.multipath}

%postun
%{insserv_cleanup}

%files
%doc AUTHOR COPYING README ChangeLog 
%doc $RPM_SOURCE_DIR/mp-tools-issues.pdf
%doc multipath.conf*
%config /etc/init.d/multipathd
%config(noreplace) /etc/multipath.conf
%config /etc/init.d/boot.multipath
/sbin/devmap_name
/sbin/multipath
/sbin/kpartx
/sbin/cciss_id
/sbin/pp_balance_units
/sbin/multipathd
/sbin/mpath_prio_alua
/sbin/mpath_prio_emc
/sbin/mpath_prio_tpc
/sbin/mpath_prio_netapp
/sbin/mpathsend
%attr (0700, root, root) /var/cache/multipath
%{_mandir}/man8/devmap_name.8*
%{_mandir}/man8/multipath.8*
%{_mandir}/man8/kpartx.8*
%{_mandir}/man8/multipathd.8*
%{_mandir}/man8/mpath_prio_alua.8*

%changelog -n multipath-tools
* Thu Jan 11 2007 - hare@suse.de
- Do not remove paths if 'boot.multipath start' is called twice
  (#170596)
- Add %%pre and %%post scripts to stop multipathd during update
  (#229950)
- Fix hwtable for HP HSV200 (#191489)
* Wed Dec 06 2006 - hare@suse.de
- Fix hwtable for HP HSV110 (#191489)
* Thu Jun 29 2006 - hare@suse.de
- Fix blacklisting of devices (#178678)
* Thu Apr 27 2006 - hare@suse.de
- Add no_path_retry extensions (#168675)
- Fix EMC hwtable to work with RAID devices (#153410)
* Mon Apr 03 2006 - hare@suse.de
- Call kpartx on startup to create all partitions (#160184)
* Fri Mar 31 2006 - hare@suse.de
- Add mpath_prio_netapp for NetApp targets (#156341)
- Allow other revisions to pp_tpc.
* Thu Mar 23 2006 - hare@suse.de
- Specify FAILBACK mode in the internal hwtable; this
  is required by some storage arrays (#160061 - LTC22476).
* Mon Mar 20 2006 - hare@suse.de
- Backport fixes from mainline; this includes fixes for
  + multipath emits too many messages #153244
  + pp_alua emits superflous 'switch to group' messages
  (#151992 - LTC21250)
  + multipath shows no devices (#156493)
* Thu Mar 02 2006 - hare@suse.de
- Use correct definitions of dev_t (#153718)
* Wed Feb 15 2006 - hare@suse.de
- Fix return value from multipath (#148847)
* Thu Feb 02 2006 - hare@suse.de
- Backport blacklisting device from mainline (#85778)
- Disable debug messages (#153244)
- Blacklist DASD by default (#148405)
* Mon Dec 05 2005 - hare@suse.de
- Ignore LUN_Z entries from EMC Clariion (#85778)
* Wed Nov 30 2005 - hare@suse.de
- Always lock maps prior to attempt changes
- Fix multipath <dev> to work properly (#132555 - LTC19610).
* Fri Nov 25 2005 - hare@suse.de
- Backport fixes from version 0.4.6.
- Add mpathsend to notify multipathd on kernel events
  (#132555 - LTC19610).
- Set paths online prior to call checkerfn (#115716).
- Add IBM SVC to hardware table (#129730 - LTC19214).
* Tue Nov 08 2005 - lmb@suse.de
- Hardware table entry now initialized correctly (#132241 - LTC19542)
- Show status when one device is offline (#102470 - LTC17229)
* Wed Nov 02 2005 - hare@suse.de
- Update hwtable to include IBM ESS and DS8000 (#129730 - LTC19214).
* Mon Oct 24 2005 - lmb@suse.de
- Skip devices for which discovery did not complete instead of aborting
  discovery, and tolerate devices with zero size (#128278).
- Include example multipath.conf file from the package itself (#129730).
* Mon Oct 24 2005 - hare@suse.de
- Really fix a build failure on ia64.
- Fix handling of dm devices in kpartx.
* Fri Sep 23 2005 - lmb@suse.de
- Fix a build failure on ia64.
* Fri Sep 23 2005 - lmb@suse.de
- Update to 0.4.5 from upstream (#86079,#85796)
* Tue Sep 20 2005 - hare@suse.de
- Fix build on SLES9 SP3.
* Wed Sep 07 2005 - lmb@suse.de
- Re-order boot.multipath to be started after hotplug (#102937).
- Respect RPM_OPT_FLAGS so that a debug build is possible (#102937).
* Mon Sep 05 2005 - matz@suse.de
- Fix broken usage of self-defined syscall [#114933].
* Fri Aug 26 2005 - hare@suse.de
- Fix kpartx DASD partition support
* Thu Aug 04 2005 - hare@suse.de
- Add 'directio' path checker
- Add support for S/390 DASD (PAV enablement).
- Update to package from SLES9
* Thu Jun 23 2005 - lmb@suse.de
- LUs with a WWN containing "fd" were blacklisted (#93562).
* Thu Jun 16 2005 - lmb@suse.de
- Remove stray newline character from /dev/disk/by-name/ entries
  (#85798, #86763)
- Clear /dev/disk/by-name/ on boot. (#85978)
- scsi_id now handles EMC Symmetrix; remove work-around for #86760.
* Tue Jun 07 2005 - lmb@suse.de
- Import fixes from upstream.
- Hardware table updates for IBM ESS and EMC CX (#81688).
- Reinstate paths correctly after failure/restore cycle (#85781,
  [#86444]).
- Create map names again and fix segfault in devmap_name (#85798).
* Tue May 24 2005 - hare@suse.de
- Fix segmentation fault with EMC Symmetrix (#85614).
- Update EMC Symmetrix entry in hwtable.
* Mon May 23 2005 - hare@suse.de
- Add hwtable entry for IBM DS6000. (#63903)
- Do a rescan for devices if multipath command line option is set.
* Fri May 20 2005 - hare@suse.de
- Fix devmap_name to use mapname and return proper status (#84748).
* Thu May 12 2005 - lmb@suse.de
- Don't complain about default prio callout command (#81695).
- Reflect recent changes in boot.multipath as well as multipathd init
  scripts.
- Actually fail paths when they are detected to be failed by multipathd
  (#81679).
- killproc/startproc/checkproc can't be used with multipathd because of
  the way the daemon switches to its own namespace (#80443).
* Mon May 09 2005 - hare@suse.de
- Use proper path checker for SGI TPC arrays.
- Update hwtable entries for SGI TP9400 and SGI TP9500.
- Write correct PID file (#80443).
* Mon Apr 25 2005 - lmb@suse.de
- Update to 0.4.4: pp_alua now licensed as GPL (#78628).
- multipath-tools-oom-adj.patch: oom_adj to a valid value.
* Thu Apr 21 2005 - lmb@suse.de
- Update to 0.4.4-pre18 which fixes the multipathd to initialize
  correctly in the absence of a configuration file (79239).
* Wed Apr 20 2005 - lmb@suse.de
- Put multipath cache back into /dev because /var might not be mounted.
- Correct hwtable entry SGI TP9400, TP9500 and IBM 3542.
* Wed Apr 20 2005 - lmb@suse.de
- Update to 0.4.4-pre16
- Build against device-mapper.1.01.xx correctly.
* Tue Apr 19 2005 - lmb@suse.de
- Build w/o device-mapper update again.
* Mon Apr 18 2005 - lmb@suse.de
- Update to 0.4.4-pre14
- Build versus device-mapper-1.01.01 to prevent deadlocks in
  kernel-space.
- Fix devmap_name to work with udev.
- Fix startup of multipathd w/o configuration file present.
* Fri Apr 15 2005 - lmb@suse.de
- Add path priority checker for EMC CLARiiON and make necessary
  adjustments so that it gets called by default (#62491).
- Set the default udev dir to '/dev'
* Fri Apr 15 2005 - hare@suse.de
- Fix to allocate default strings (#78056)
- Fix default entry for TPC9500.
* Wed Apr 13 2005 - hare@suse.de
- Added pp_alua path priority checker.
- Update to multipath-tools-0.4.4-pre12.
* Mon Apr 11 2005 - hare@suse.de
- Update to multipath-tools-0.4.4-pre10.
* Fri Apr 08 2005 - hare@suse.de
- Update multipath to handle only true multipath devices (#62491).
- Update kpartx to use the device mapper target name if available.
- Add boot.multipath script for early set up of multipath targets.
* Thu Mar 31 2005 - hare@suse.de
- Update devmap_name to select targets by table type (#62493).
* Tue Jan 25 2005 - lmb@suse.de
- Update to 0.4.2 and fix some bugs + add support for the extended DM
  multipath kernel module. (#47491)
* Thu Nov 11 2004 - hare@suse.de
- Fix bugs to make it work on S/390 (#47491).
* Fri Nov 05 2004 - hare@suse.de
- Update to version 0.3.6 (#47491).
- Fix multipath init script
- Install configuration file example.
- Install multipathd in /sbin instead of /usr/bin.
* Tue Jul 20 2004 - fehr@suse.de
- updated README mp-tools-issues.pdf (see #40640)
* Wed Jun 09 2004 - fehr@suse.de
- added pdf with README to package (see #40640)
* Thu Jun 03 2004 - fehr@suse.de
- updated to version 0.2.1
- removed patches zero-currpath.patch and rm-newline-in-name.patch
  already contained in 0.2.1
* Thu Jun 03 2004 - fehr@suse.de
- added patch zero-currpath.patch (see bugzilla #40640)
* Wed May 26 2004 - uli@suse.de
- fixed to build on s390x
* Wed May 26 2004 - fehr@suse.de
- added patch rm-newline-in-name.patch (see bugzilla #40640)
* Tue May 25 2004 - fehr@suse.de
- created initial version of a SuSE package from version 0.2.0 of
  multipath tools
